<template>
  <el-main>
    <el-row>
      <el-col :span="2">
        <el-select v-model="input_type">
          <el-option label="csv"  value="csv"></el-option>
          <el-option label="tsv"  value="tsv"></el-option>
          <el-option label="json" value="json"></el-option>
        </el-select>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="input"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="11">
        <el-button @click="convert" type="primary" round>変更！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2">
        <el-select v-model="output_type">
          <el-option label="csv"  value="csv"></el-option>
          <el-option label="tsv"  value="tsv"></el-option>
          <el-option label="json" value="json"></el-option>
        </el-select>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <label>output</label>
      </el-col>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>

</template>

<script>
import _ from 'lodash'

export default {
  data() {
    return {
      input_type: "tsv",
      input: "",
      output_type: "json",
      output: "",
    }
  },
  methods: {
    convert() {
        const data = this.convertInputToData(this.input, this.input_type)
        const result = this.convertFromData(data, this.output_type)
        this.output = result
    },

    convertInputToData(input, type) {
      let result = []
      
      if (type === "csv" || type === "tsv") {
        const delimiter = type === "tsv"? "\t" : ","
        const lines = input.split("\n")
        const header = lines.shift().split(delimiter)
        const values = _.map(lines, (line) => line.split(delimiter))

        result = _.map(values, (value) => {
          if (header.length != value.length) {
            this.$message({
              showClose: true,
              message: "ヘッダとデータの数が合っていません",
              type: "error"
            })
            return
          }

          return _.zipObject(header, value)
        })
      } else if (type === "json") {
        result = JSON.parse(input)
      }

      return result
    },

    convertFromData(data, type) {
      let result = ""

      if (!_.isArray(data) || data.length === 0) {
        return ""
      }

      if (type === "csv" || type === "tsv") {
        const delimiter = type === "tsv"? "\t" : ","
        const header = Object.keys(data[0])
        result += header.join(delimiter) + "\n"

        _.forEach(data, (d) => {
          const values = Object.values(d)
          result += values.join(delimiter) + "\n"
        })
      } else if (type === "json") {
        result = JSON.stringify(data)
      }

      return result
    }
  }
}
</script>
